\subsection{Towards incrementality}

\begin{frame}{Towards incrementality}
	$\sim 2010$: How can we solve nonlinear real arithmetic in SMT?
	\pause

	\begin{itemize}
		\item CAD \emph{established for quantifier elimination}
		\item First attempts with CAD \emph{seem promising} \cite{Loup2011,Corzilius2012,Loup2013}
		\item Since $2016$: SC$^2$
	\end{itemize}
	
	\pause\bigskip

	Our goal: make CAD \emph{as efficient as possible for SMT}

	\pause\bigskip

	\begin{itemize}
		\item Incrementality: \emph{reuse} previously computed results
		\item Backtracking: remove part of the input \emph{efficiently}
		\item Reasons for unsatisfiability: \emph{small} infeasible subsets
	\end{itemize}
\end{frame}

\begin{frame}{Incremental lifting \hfill{} \citeown{Kremer2020}}
	\citefootline{\cite{Collins1991}}
	\centering
	\includetikz{02b-cad-incremental-lifting}
\end{frame}

\begin{frame}{Incremental projection \hfill{} \citeown{Kremer2020}}
	\centering
	\includetikz{02b-cad-incremental-projection}
\end{frame}
